mainpage.md

    #WelcometoLibusermetrics

    Libusermetricsenablesappstolocallystoreinterestingnumericaldata
    forlaterpresentation.ForexampleintheUbuntuGreeter"flower"
    infographic.

    -Alldataisstoredlocallyin/var/usermetrics/.
    -Nodataiscentrallycollectedviaaweb-seriviceorotherwise,and
    nodataissentovertheinternet.

    Theonlydatathatcanbestoredisnumerical,forexample"numberof
    e-mails"or"numberofpicturestaken".Nopersonallyidentifying
    informationisstoredusingthislibrary.

    **WARNING:**ThisAPIshouldbeconsideredprivate,andisonlyforuseby
    firstpartyapplicationsatpresent.Itmaychangeorberemovedatany
    time.

    ##Gettingandinstallinglibusermetrics

    ###Usingpre-builtpackages

    Ifyoujustwanttotryoutlibusermetrics,orwriteusermetricssources,
    thentheeasiestwayistousethe[pre-builtpackages](doc/pages/installing_prebuilt.md).

    ###Buildingandinstallingfromsource

    Ifyouarecuriousaboutlibusermetrics'sinternalsorintendtocontributeto
    it,youshould[getthesourceandbuildit](doc/pages/building_source.md).

    Gettinginvolved
    ----------------

    Thebestplacetoaskquestionsanddiscussaboutlibusermetricsisthe\#ubuntu-touch
    IRCchannelonfreenode.

    ThelibusermetricsprojectishostedonGitLab:https://gitlab.com/ubports/core/libusermetrics

    Pleasefilebugreportsat:http://gitlab.com/ubports/core/libusermetrics/-/issues

    Writingmetricdatasources
    ---------------------------

    -\refUserMetricsInput"LibusermetricsInputAPIDocumentation"

    Forsimplemetricswhichonlywanttoincrementacounter,seethefollowingexamples:

    -\subpageMetricManagerIncrementToday.cpp"MetricManagerIncrementToday.cpp:AsimpleQt-basedmetric"
    -\subpageMetricManagerIncrementTodayCAPI.c"MetricManagerIncrementTodayCAPI.c:AsimpleC-basedmetric"

    Forsimplemetricswhichonlywanttoupdatetoday'svalue,butcannotsimplyincrementit,
    seethefollowingexamples:

    -\subpageMetricManagerUpdateToday.cpp"MetricManagerUpdateToday.cpp:AsimpleQt-basedmetric"
    -\subpageMetricManagerUpdateTodayCAPI.c"MetricManagerUpdateTodayCAPI.c:AsimpleC-basedmetric"

    Formoresophisticatedmetrics,whichwishtoupdatethehistoryofthemetric,for
    exampleiftheuserhasbeenofflineforaweek.Pleaseseethefollowingexamples:

    -\subpageMetricManagerAdvanced.cpp"MetricManagerAdvanced.cpp:AQt-basedmetric"
    -\subpageMetricManagerAdvancedCAPI.c"MetricManagerAdvancedCAPI.c:AC-basedmetric"

    Writingapresentationapplication
    ----------------------------------

    Towriteametricpresentationapplication,thereisaQtAPI.

    -\refUserMetricsOutput"LibusermetricsOutputAPIDocumentation"
    -Agoodexampletorefertoisthe
    [infographics](https://gitlab.com/ubports/core/lomiri/-/blob/main/qml/Greeter/Infographics.qml)
    fortheLomirigreeter.